import { world } from '@minecraft/server';
import { useTypes, commandSubject } from '../Interfaces/on_Use_Interfaces';
const on_Use = [
     {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:apple",
        code_type: {
            command: {
                commands: [
                    "function consume/apple"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:baked_potato",
        code_type: {
            command: {
                commands: [
                    "function consume/baked_potato"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:beetroot",
        code_type: {
            command: {
                commands: [
                    "function consume/beetroot"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:beetroot_soup",
        code_type: {
            command: {
                commands: [
                    "function consume/beetroot_soup"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:bread",
        code_type: {
            command: {
                commands: [
                    "function consume/bread"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:carrot",
        code_type: {
            command: {
                commands: [
                    "function consume/carrot"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:chorus_fruit",
        code_type: {
            command: {
                commands: [
                    "function consume/chorus_fruit"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_chicken",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_chicken"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_cod",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_cod"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_mutton",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_mutton"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_porkchop",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_porkchop"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_rabbit",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_rabbit"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cooked_salmon",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_salmon"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {

        use_type: useTypes.Item_Complete_Use,

        itemID: "minecraft:cooked_beef",
        code_type: {
            command: {
                commands: [
                    "function consume/cooked_beef"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cookie",
        code_type: {
            command: {
                commands: [
                    "function consume/cookie"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:dried_kelp",
        code_type: {
            command: {
                commands: [
                    "function consume/dried_kelp"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:glow_berries",
        code_type: {
            command: {
                commands: [
                    "function consume/glow_berries"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:golden_apple",
        code_type: {
            command: {
                commands: [
                    "function consume/golden_apple"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:golden_carrot",
        code_type: {
            command: {
                commands: [
                    "function consume/golden_carrot"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:honey_bottle",
        code_type: {
            command: {
                commands: [
                    "function consume/honey_bottle"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:melon_slice",
        code_type: {
            command: {
                commands: [
                    "function consume/melon_slice"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:mushroom_stew",
        code_type: {
            command: {
                commands: [
                    "function consume/mushroom_stew"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:enchanted_golden_apple",
        code_type: {
            command: {
                commands: [
                    "function consume/notch_apple"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:tropical_fish",
        code_type: {
            command: {
                commands: [
                    "function consume/tropical_fish"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:potato",
        code_type: {
            command: {
                commands: [
                    "function consume/potato"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:pufferfish",
        code_type: {
            command: {
                commands: [
                    "function consume/pufferfish"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:pumpkin_pie",
        code_type: {
            command: {
                commands: [
                    "function consume/pumpkin_pie"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:rabbit_stew",
        code_type: {
            command: {
                commands: [
                    "function consume/rabbit_stew"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:beef",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_beef"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:mutton",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_mutton"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:porkchop",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_porkchop"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:rabbit",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_rabbit"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:salmon",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_salmon"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:chicken",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_chicken"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:cod",
        code_type: {
            command: {
                commands: [
                    "function consume/raw_cod"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:suspicious_stew",
        code_type: {
            command: {
                commands: [
                    "function consume/sus_stew"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:sweet_berries",
        code_type: {
            command: {
                commands: [
                    "function consume/sweet_berries"
                ],
                subject: commandSubject.Player
            }
        }
    },
    {
        use_type: useTypes.Item_Use,
        itemID: "minecraft:stick",
        code_type: {
            command: {
                commands: [
                    "function info"
                ],
                subject: commandSubject.Player
            }
        }
    }
];
const itemUses = [
    world.afterEvents.itemUse,
    world.afterEvents.itemUseOn,
    world.afterEvents.itemCompleteUse,
    world.afterEvents.itemReleaseUse,
    world.afterEvents.itemStartUse,
    world.afterEvents.itemStartUseOn,
    world.afterEvents.itemStopUse,
    world.afterEvents.itemStopUseOn
];
const itemUsesTypes = [
    useTypes.Item_Use,
    useTypes.Item_Use_On,
    useTypes.Item_Complete_Use,
    useTypes.Item_Release_Use,
    useTypes.Item_Start_Use,
    useTypes.Item_Start_Use_On,
    useTypes.Item_Stop_Use,
    useTypes.Item_Stop_Use_On
];
for (let i = 0; i < itemUses.length; i++) {
    const itemUse = itemUses[i];
    itemUse.subscribe((data) => {
        const code = on_Use.find((f) => f.use_type == itemUsesTypes[i] && f.itemID == data.itemStack.typeId);
        if (code == undefined) return;
        const command = code.code_type.command;
        const func = code.code_type.code;
        if (func != undefined) {
            func(data);
        }
        if (command != undefined) {
            let subject = data.source;
            if (command.subject == commandSubject.Dimension) subject = data.source.dimension;
            for (const cmd of command.commands) {
                subject.runCommand(cmd);
            }
        }
    });
}
